/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/


#include "cursore.h"
#include "funzioniS.h"
#include <ncurses.h>


Cursore::Cursore()
 :x((FunzioniS::riqDx + FunzioniS::riqSx)/ 2), y(FunzioniS::riqGiu),
	xg(24), yg(49), c('0')
{
}

void Cursore::inserisciInMatriceGioco()
{
	FunzioniS::matriceGioco[xg][yg] = getC();

	attron(COLOR_PAIR(5));
	mvprintw(y, x, "0");
	attron(COLOR_PAIR(3));
	move(y, x);
	refresh();
}


void Cursore::inserisciInMatriceGioco(int rx, int ry)
{

	yg = rx;
	xg = ry;

	x = yg+20;
	y = xg+2;

	inserisciInMatriceGioco();

}


int Cursore::getX() const
{
	return x;
}

int Cursore::getY() const
{
	return y;
}

int Cursore::getXG() const
{
	return xg;
}

int Cursore::getYG() const
{
	return yg;
}

char Cursore::getC() const
{
	return c;
}





void Cursore::moveToLeft()
{
	bool sonoSuS = false;

	if(yg == 98 || FunzioniS::matriceGioco[xg][yg+1] == 'c' || FunzioniS::matriceGioco[xg][yg+1] == 's'
		|| yg+1 == 98)
	{
		FunzioniS::iniziato = true;
		FunzioniS::dirInizio = 'r';
	}



	if(x != FunzioniS::riqSx && FunzioniS::matriceGioco[xg][yg-1] != 'p')
	{
		if(FunzioniS::matriceGioco[xg][yg-1] == '*')
		{
			FunzioniS::cacciaVita();
		}
		else if( FunzioniS::matriceGioco[xg][yg-1] != 'c')  //perchè c indica il carattere di casella conquistata
		{

			if (FunzioniS::matriceGioco[xg][yg-1] == 's')
			{
				sonoSuS = true;

				//prima parte: per la matrice a schermo di ncurses
				attron(COLOR_PAIR(4));
				mvprintw(y,x, "-");
				attron(COLOR_PAIR(3));
				x= x-1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				//seconda parte: per la matrice statica del gioco 
				FunzioniS::matriceGioco[xg][yg] = 's';
				yg--;
				FunzioniS::matriceGioco[xg][yg] = '0';



			}
			else
			{	
				//prima parte: per la matrice a schermo di ncurses
				attron(COLOR_PAIR(4));
				mvprintw(y,x, "-");
				attron(COLOR_PAIR(3));
				x= x-1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				//seconda parte: per la matrice statica del gioco 
				FunzioniS::matriceGioco[xg][yg] = 'p';
				yg--;
				FunzioniS::matriceGioco[xg][yg] = '0';

			}

		}
	}


	if( (yg == 0 || FunzioniS::matriceGioco[xg][yg-1] == 'c' || (sonoSuS && yg-1 == 0)
		 && FunzioniS::iniziato == true && FunzioniS::matriceGioco[xg][yg-1] != '*') )
	{
		FunzioniS::dirFine = 'l';

		FunzioniS::chiusuraBlocco();
		FunzioniS::disegnaBlocco();
		move(y,x);

		FunzioniS::calcolaPercentuale();
		move(y,x);

		FunzioniS::calcolaPunteggio();
		move(y,x);

		FunzioniS::azzeraChiusuraBlocco();
		FunzioniS::cambiaPinS();
	}

}



void Cursore::moveToRight()
{
	bool sonoSuS = false;

	if(yg == 0 || FunzioniS::matriceGioco[xg][yg-1] == 'c' || FunzioniS::matriceGioco[xg][yg-1] == 's'
		|| yg-1 == 0)
	{
		FunzioniS::iniziato = true;
		FunzioniS::dirInizio = 'l';
	}


	if(x != FunzioniS::riqDx && FunzioniS::matriceGioco[xg][yg+1] != 'p')
	{

		if(FunzioniS::matriceGioco[xg][yg+1] == '*')
		{
			FunzioniS::cacciaVita();
		}
		else if( FunzioniS::matriceGioco[xg][yg+1] != 'c')
		{

			if(FunzioniS::matriceGioco[xg][yg+1] == 's')
			{
				sonoSuS = true;

				attron(COLOR_PAIR(4));
				mvprintw(y,x, "-");
				attron(COLOR_PAIR(3));
				x= x+1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				FunzioniS::matriceGioco[xg][yg] = 's';
				yg++;
				FunzioniS::matriceGioco[xg][yg] = '0';


			}
			else
			{
				attron(COLOR_PAIR(4));
				mvprintw(y,x, "-");
				attron(COLOR_PAIR(3));
				x= x+1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				FunzioniS::matriceGioco[xg][yg] = 'p';
				yg++;
				FunzioniS::matriceGioco[xg][yg] = '0';


			}
		}
	}

	
	if( (yg == 98  || FunzioniS::matriceGioco[xg][yg+1] == 'c'|| (yg+1 == 98 && sonoSuS)
		&& FunzioniS::iniziato == true && FunzioniS::matriceGioco[xg][yg+1] != '*') )
	{
		FunzioniS::dirFine = 'r';

		FunzioniS::chiusuraBlocco();
		FunzioniS::disegnaBlocco();
		move(y,x);

		FunzioniS::calcolaPercentuale();
		move(y,x);

		FunzioniS::calcolaPunteggio();
		move(y,x);

		FunzioniS::azzeraChiusuraBlocco();
		FunzioniS::cambiaPinS();
	}

}



void Cursore::moveToUp()
{
	bool sonoSuS = false;

	if(xg == 24 || FunzioniS::matriceGioco[xg+1][yg] == 'c' || FunzioniS::matriceGioco[xg+1][yg] == 's'
		|| xg+1 == 24)
	{
		FunzioniS::iniziato = true;
		FunzioniS::dirInizio= 'd';
	}



	if(y != FunzioniS::riqSu && FunzioniS::matriceGioco[xg-1][yg] != 'p')
	{
		if(FunzioniS::matriceGioco[xg-1][yg] == '*')
		{
			FunzioniS::cacciaVita();
		}
		else if( FunzioniS::matriceGioco[xg-1][yg] != 'c')
		{
		
			if(FunzioniS::matriceGioco[xg-1][yg] == 's')
			{
				sonoSuS = true;

				attron(COLOR_PAIR(4));
				mvprintw(y,x, "|");
				attron(COLOR_PAIR(3));
				y= y-1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				FunzioniS::matriceGioco[xg][yg] = 's';
				xg--;
				FunzioniS::matriceGioco[xg][yg] = '0';


			}
			else
			{

				attron(COLOR_PAIR(4));
				mvprintw(y,x, "|");
				attron(COLOR_PAIR(3));
				y= y-1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();

				FunzioniS::matriceGioco[xg][yg] = 'p';
				xg--;
				FunzioniS::matriceGioco[xg][yg] = '0';
			}

		}
	
	}


	if( (xg == 0 || FunzioniS::matriceGioco[xg-1][yg] == 'c' || (sonoSuS && xg-1 == 0)
		&& FunzioniS::iniziato == true && FunzioniS::matriceGioco[xg-1][yg] != '*') )
	{
		FunzioniS::dirFine = 'u';

		FunzioniS::chiusuraBlocco();
		FunzioniS::disegnaBlocco();
		move(y,x);

		FunzioniS::calcolaPercentuale();
		move(y,x);

		FunzioniS::calcolaPunteggio();
		move(y,x);
		
		FunzioniS::azzeraChiusuraBlocco();
		FunzioniS::cambiaPinS();
	}


}


void Cursore::moveToDown()
{
	bool sonoSuS = false;

	if(xg == 0 || FunzioniS::matriceGioco[xg-1][yg] == 'c' || FunzioniS::matriceGioco[xg-1][yg] == 's'
		|| xg-1 == 0)
	{
		FunzioniS::iniziato = true;
		FunzioniS::dirInizio = 'u';
	}


	if(y != FunzioniS::riqGiu && FunzioniS::matriceGioco[xg+1][yg] != 'p')
	{
		if(FunzioniS::matriceGioco[xg+1][yg] == '*')
		{
			FunzioniS::cacciaVita();
		}
		else if( FunzioniS::matriceGioco[xg+1][yg] != 'c')
		{

			if(FunzioniS::matriceGioco[xg+1][yg] == 's')
			{
				sonoSuS = true;

				attron(COLOR_PAIR(4));
				mvprintw(y,x, "|");
				attron(COLOR_PAIR(3));
				y= y+1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();


				FunzioniS::matriceGioco[xg][yg] = 's';
				xg++;
				FunzioniS::matriceGioco[xg][yg] = '0';


			}
			else
			{
			
				attron(COLOR_PAIR(4));
				mvprintw(y,x, "|");
				attron(COLOR_PAIR(3));
				y= y+1;
				move(y, x);
				attron(COLOR_PAIR(5));
				printw("0");
				attron(COLOR_PAIR(3));
				move(y,x);
				refresh();


				FunzioniS::matriceGioco[xg][yg] = 'p';
				xg++;
				FunzioniS::matriceGioco[xg][yg] = '0';

			}
		}

	}


	if( (xg == 24 || FunzioniS::matriceGioco[xg+1][yg] == 'c' || (sonoSuS && xg+1 == 24) 
		&& FunzioniS::iniziato == true && FunzioniS::matriceGioco[xg+1][yg] != '*') )
	{
		FunzioniS::dirFine = 'd';

		FunzioniS::chiusuraBlocco();
		FunzioniS::disegnaBlocco();
		move(y,x);

		FunzioniS::calcolaPercentuale();
		move(y,x);

		FunzioniS::calcolaPunteggio();
		move(y,x);

		FunzioniS::azzeraChiusuraBlocco();
		FunzioniS::cambiaPinS();
	}
}
