/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/



#include "dominator.h"
#include "funzioniS.h"
#include <ncurses.h>
#include <ctime>
#include <cstdlib>


int Dominator::getDX() const
{
	return dx;
}

int Dominator::getDY() const
{
	return dy;
}

int Dominator::getDXG() const
{
	return dxg;
}

int Dominator::getDYG() const
{
	return dyg;
}


Dominator::Dominator()
 : dx(69), dy(15), dxg(13), dyg(49)
{
}



void Dominator::inserisciInMatriceGioco()
{
	FunzioniS::matriceGioco[dxg][dyg] = '@';

	attron(COLOR_PAIR(3));
	mvprintw(dy, dx, "@");
	move(dy, dx);
	refresh();
}


void Dominator::inserisciInMatriceGioco(int px, int py)
{
	dyg = px;
	dxg = py;

	dx = dyg+20;
	dy = dxg+2;

	inserisciInMatriceGioco();
}


void Dominator::stampa()
{
	if(FunzioniS::contGenerale == 0 || FunzioniS::contGenerale == 3)
		colore = generaColore();


	switch(colore)
	{
		case 0:
			attron(COLOR_PAIR(14));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


		case 1:
			attron(COLOR_PAIR(15));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


		case 2:
			attron(COLOR_PAIR(16));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


		case 3:
			attron(COLOR_PAIR(17));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


		case 4:
			attron(COLOR_PAIR(18));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


		case 5:
			attron(COLOR_PAIR(19));
			mvprintw(dy,dx, "@");
			attron(COLOR_PAIR(3));
			break;


	}



}


void Dominator::muovi()
{
	direzione = scegliDirezione();

	switch(direzione)
	{
		
		case 0: //sopra
			if(FunzioniS::matriceGioco[dxg-1][dyg] == 'p' || FunzioniS::matriceGioco[dxg-1][dyg] == '0')
				FunzioniS::cacciaVita();
			else if(dxg >1 && FunzioniS::matriceGioco[dxg-1][dyg] != 's')
			{
				mvprintw(dy, dx, " ");
				dy= dy-1;
				stampa();

				FunzioniS::matriceGioco[dxg][dyg] = '\0';
				dxg--;
				FunzioniS::matriceGioco[dxg][dyg] = '@';
				
			}
			else
			{
				if(dyg >1 && FunzioniS::matriceGioco[dxg][dyg-1] != 's') //sinistra
				{
					if(FunzioniS::matriceGioco[dxg][dyg-1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg-1] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				}
				else if(dyg < 97 && FunzioniS::matriceGioco[dxg][dyg+1]!= 's') //destra
				{
					if(FunzioniS::matriceGioco[dxg][dyg+1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg+1]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if( dxg <23 && FunzioniS::matriceGioco[dxg+1][dyg]!= 's') //sotto
				{
					if(FunzioniS::matriceGioco[dxg+1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg+1][dyg]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				}
				
			
			}

			break;
			



		case 1: //destra
			
			if(FunzioniS::matriceGioco[dxg][dyg+1] == 'p' || FunzioniS::matriceGioco[dxg][dyg+1]== '0')
				FunzioniS::cacciaVita();
			else if(dyg < 97 && FunzioniS::matriceGioco[dxg][dyg+1]!= 's')
			{
				mvprintw(dy, dx, " ");
				dx= dx+1;
				stampa();

				FunzioniS::matriceGioco[dxg][dyg] = '\0';
				dyg++;
				FunzioniS::matriceGioco[dxg][dyg] = '@';
				
			}
			else
			{
				if(dxg >1 && FunzioniS::matriceGioco[dxg-1][dyg] != 's') //sopra
				{
					if(FunzioniS::matriceGioco[dxg-1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg-1][dyg] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if( dxg <23 && FunzioniS::matriceGioco[dxg+1][dyg]!= 's') //sotto
				{
					if(FunzioniS::matriceGioco[dxg+1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg+1][dyg]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if(dyg >1 && FunzioniS::matriceGioco[dxg][dyg-1] != 's') //sinistra
				{
					if(FunzioniS::matriceGioco[dxg][dyg-1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg-1] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				}

			}

			break;



		case 2: //sotto

			if(FunzioniS::matriceGioco[dxg+1][dyg] == 'p' || FunzioniS::matriceGioco[dxg+1][dyg]== '0')
				FunzioniS::cacciaVita();
			else if( dxg <23 && FunzioniS::matriceGioco[dxg+1][dyg]!= 's')
			{
				mvprintw(dy, dx, " ");
				dy= dy+1;
				stampa();

				FunzioniS::matriceGioco[dxg][dyg] = '\0';
				dxg++;
				FunzioniS::matriceGioco[dxg][dyg] = '@';
				
			}
			else
			{
				if(dyg < 97 && FunzioniS::matriceGioco[dxg][dyg+1]!= 's') //destra
				{
					if(FunzioniS::matriceGioco[dxg][dyg+1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg+1]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if(dyg >1 && FunzioniS::matriceGioco[dxg][dyg-1] != 's') //sinistra
				{
					if(FunzioniS::matriceGioco[dxg][dyg-1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg-1] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				}
				else if(dxg >1 && FunzioniS::matriceGioco[dxg-1][dyg] != 's') //sopra
				{
					if(FunzioniS::matriceGioco[dxg-1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg-1][dyg] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
			}
			
			break;



		case 3: //sinistra

			if(FunzioniS::matriceGioco[dxg][dyg-1] == 'p' || FunzioniS::matriceGioco[dxg][dyg-1] == '0')
				FunzioniS::cacciaVita();
			else if(dyg >1 && FunzioniS::matriceGioco[dxg][dyg-1] != 's')
			{
				mvprintw(dy, dx, " ");
				dx= dx-1;
				stampa();

				FunzioniS::matriceGioco[dxg][dyg] = '\0';
				dyg--;
				FunzioniS::matriceGioco[dxg][dyg] = '@';
				
			}
			else
			{
				if( dxg <23 && FunzioniS::matriceGioco[dxg+1][dyg]!= 's') //sotto
				{
					if(FunzioniS::matriceGioco[dxg+1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg+1][dyg]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if(dxg >1 && FunzioniS::matriceGioco[dxg-1][dyg] != 's') //sopra
				{
					if(FunzioniS::matriceGioco[dxg-1][dyg] == 'p' 
					|| FunzioniS::matriceGioco[dxg-1][dyg] == '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dy= dy-1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dxg--;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}
				else if(dyg < 97 && FunzioniS::matriceGioco[dxg][dyg+1]!= 's') //destra
				{
					if(FunzioniS::matriceGioco[dxg][dyg+1] == 'p' 
					|| FunzioniS::matriceGioco[dxg][dyg+1]== '0')
						FunzioniS::cacciaVita();
					else
					{
						mvprintw(dy, dx, " ");
						dx= dx+1;
						stampa();

						FunzioniS::matriceGioco[dxg][dyg] = '\0';
						dyg++;
						FunzioniS::matriceGioco[dxg][dyg] = '@';
					}
				
				}

			}
			break;

	}


}


int Dominator::scegliDirezione()
{
	srand(time(0)); 
	
	int tmpd = rand();

	while(FunzioniS::tempf == tmpd)
		tmpd = rand();

	FunzioniS::tempf = tmpd;


	return tmpd %4;

	//0- sopra
	//1- destra
	//2- sotto
	//3- sinistra
}


int Dominator::generaColore()
{
	srand(time(0)); 
	
	int tmpd = rand();

	while(FunzioniS::temph == tmpd)
		tmpd = rand();

	FunzioniS::temph = tmpd;


	return tmpd %6;
}
