/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/



#ifndef FUNZIONIS_H
#define FUNZIONIS_H

#include "cursore.h"
#include "strisciatore.h"
#include "dominator.h"


class FunzioniS
{
	public:
		static int vite;
		static bool fineGioco;
		static int contGenerale;
		static bool persaVita;

		static int tempd; //direzione degli strisciatori temporanea
		static int temph; //colore dei dominator temporaneo
		static int tempf; //direzione dei dominator temporanea

		static void cacciaVita();

		static int dimr; //dimensione delle righe del riquadro generale
		static int dimc; //dimensione delle colonne del riquadro generale
		static int riqSu; //riga tetto del riquadro di gioco
		static int riqGiu; //riga base del riquadro di gioco
		static int riqSx; //colonna tetto sinistra del riquadro del gioco
		static int riqDx; //colonna tetto destra del riquadro di gioco

		static bool iniziato; //booleano che mi dice se è iniziata la chiusura del blocco
		static char dirInizio; //direzione di chiusura iniziale l=sinistra r=destra u=sopra d=sotto n=none
		static char dirFine; //direzione di chiusura finale l=sinistra r=destra u=sopra d=sotto n=none

		static int percentuale;
		static int vperc;
		static int punteggio;

		static char matriceGioco[25][99]; //matrice che contiene tutto quello che accade nel gioco


		static void inizializzaSchermo();
		static void intro(Cursore &cur, Strisciatore &stri1, Strisciatore &stri2, Dominator &dom1, Dominator &dom2);
		static void stampaSchermo();
		static void countdown();

		static void resettaMatriceGioco();

		static void spostamentoCursore(int &movimento, Cursore &cur);
		
		static void inizializzaMatriceGioco();
		static void stampaMatriceGioco();
		static void disegnaContorno();

		static void azzeraChiusuraBlocco();
		static void chiusuraBlocco();	
		static void cambiaPinS();

	
		//tipi di chiusura (le lettere in maiuscolo indicano le direzioni di inizio e di fine
		static void lockDeR();  //metodo scorrimento da sinistra a destra dall'alto in basso
		static void lockDeL();	//metodo scorrimento da destra a sinistra dall'alto in basso
		static void lockLeR();	//metodo scorrimento da sopra a sotto da destra a sinistra


		static void disegnaBlocco();

		static void calcolaPercentuale();
		static void calcolaPunteggio(); 

};
#endif
