/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/



#include <ncurses.h>
#include "funzioniS.h"
#include "cursore.h"
#include "strisciatore.h"
#include "dominator.h"
#include "menu.h"
#include "classifica.h"




int main()
{

	int movimento;
	int rispcf;
	Cursore cur;
	Strisciatore stri1;
	Strisciatore stri2;
	Dominator dom1;
	Dominator dom2;
	Menu menup;
	Classifica highscore;
	

	initscr();
	start_color();
	noecho();

	highscore.caricaClassifica();

	do{
		erase();

		FunzioniS::vite = 3;
		FunzioniS::punteggio = 0;
		FunzioniS::percentuale =0;
		FunzioniS::fineGioco = false;

		menup.creaMenu();
		menup.disegnaScritta();
		rispcf = menup.cosaFare();
		menup.cancellaMenu();
		refresh();

		if(rispcf == 'n')
		{

			FunzioniS::inizializzaSchermo();

			do{

				FunzioniS::intro(cur, stri1, stri2, dom1, dom2);


				do{
					timeout(100);
					movimento = getch();


					if(movimento == 'p')
					{
						do{
							mvprintw(23, 7, "PAUSA");
							mvprintw(25, 6, "premi P");
							mvprintw(26, 8, "per");
							mvprintw(27, 5, "riprendere");
							timeout(1000);
							movimento = getch();
						}while(movimento != 'p');

						mvprintw(23,7, "     ");
						mvprintw(25, 6, "       ");
						mvprintw(26, 8, "   ");
						mvprintw(27, 5, "          ");		
					}

					FunzioniS::spostamentoCursore(movimento, cur);
		
					FunzioniS::contGenerale++;

					if(FunzioniS::contGenerale == 4)
						FunzioniS::contGenerale = 0;

					if(FunzioniS::persaVita == true)
						break;

					if(FunzioniS::percentuale >= 75)
					{
						attron(COLOR_PAIR(13));
					mvprintw(0,30,"HAI RAGGIUNTO L'OBBIETTIVO SE VUOI TERMINARE QUI IL GIOCO PREMI E");
						attron(COLOR_PAIR(3));
					}

					FunzioniS::disegnaContorno();

					stri1.muovi();
					stri2.muovi();

			 if(FunzioniS::contGenerale == 0 || FunzioniS::contGenerale == 2 || FunzioniS::contGenerale == 3)
					{
						dom1.muovi();
						dom2.muovi();
					}

					refresh();

				}while( movimento != 'e');

		
				if(FunzioniS::persaVita == true)
				{
					attron(COLOR_PAIR(10));
					mvprintw(1, 50, "HAI PERSO UNA VITA");
					attron(COLOR_PAIR(3));
					refresh();
					napms(2000);

					mvprintw(1, 50, "                  ");
					refresh();
				}

				if(movimento == 'e')
					break;

			}while(FunzioniS::fineGioco == false);

			if(FunzioniS::percentuale >= 75)
			{
				attron(COLOR_PAIR(12));
				mvprintw(12, 48, "HAI VINTOOOO!!!");
				mvprintw(14, 47, "IL TUO PUNTEGGIO E':");
				mvprintw(15, 52, "%i", FunzioniS::punteggio);
				mvprintw(16, 53, " x ");
				mvprintw(17, 54, "%i", FunzioniS::vite);
				mvprintw(19, 46, "PUNTEGGIO FINALE:");
				int puntFinale = FunzioniS::punteggio * FunzioniS::vite;
				mvprintw(20, 52, "%i", puntFinale);
				refresh();
				napms(6000);
				attron(COLOR_PAIR(3));


				highscore.aggiungiInClassifica(puntFinale);
				highscore.ordinaClassifica();

			}
			else
			{
				attron(COLOR_PAIR(10));
				mvprintw(12, 48, "HAI PERSO!!!");
				refresh();
				napms(3000);
				attron(COLOR_PAIR(3));
			}

			erase();
			refresh();
		}

		else if ( rispcf == 'c')
		{
			/*
			init_pair(40, COLOR_WHITE, COLOR_BLACK);
			attron(COLOR_PAIR(40));
			mvprintw(18, 80, "(funzione non ancora disponibile)");
			refresh();*/


			highscore.stampaClassifica();

		}
	
	}while(rispcf != 'e');

	endwin();

	highscore.salvaClassifica();


	//FunzioniS::stampaMatriceGioco();

return 0;
}
